/*--------------------------------------------------------------------------------------*/
/*	GENERAL TYPES DEFINITIONS (new scalar types with explicit sizes)		*/
/*											*/
/*--------------------------------------------------------------------------------------*/

#ifndef TYPES_H
#define TYPES_H

/* ====	 Some constants ==== */
#ifndef NULL
#define	NULL		0
#endif !NULL

#ifndef FALSE
#define FALSE		0
#endif !FALSE

#ifndef TRUE
#define TRUE		1
#endif !TRUE


/* ====	 Explicitly sized types ==== */

#ifndef bool
#define	bool		char				/* Boolean type			*/
#endif
typedef unsigned char	boolean;
typedef char		int8;				/* 8 bit wide types		*/
typedef unsigned char	uint8;
typedef short		int16;				/* 16 bit wide types		*/
typedef unsigned short	uint16;
typedef long		int32;				/* 32 bit wide types		*/
typedef unsigned long	uint32;
typedef float		real32;				/* Floating point types		*/
typedef double		real64;
typedef	short		f5_11;				/* Fixed point: <f>int_fract	*/
typedef	long		f8_24;

typedef char		*string;			/* Pointer to char(s)		*/
typedef void		*pointer;			/* Pointer to any type		*/

#define	CHAR		0
#define BOOLEAN		1
#define INT8		2
#define UINT8		3
#define INT16		4
#define UINT16		5
#define INT32		6
#define UINT32		7
#define REAL32		8
#define REAL64		9
#define STRING		10
#define POINTER		11
#define F5_11		12
#define F8_24		13
#define NB_TYPE_TAGS	14

#endif TYPES_H
